/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.api;

import io.docs_dispatcher.client.ApiCallback;
import io.docs_dispatcher.client.ApiClient;
import io.docs_dispatcher.client.ApiException;
import io.docs_dispatcher.client.ApiResponse;
import io.docs_dispatcher.client.Configuration;
import io.docs_dispatcher.client.Pair;
import io.docs_dispatcher.client.ProgressRequestBody;
import io.docs_dispatcher.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.docs_dispatcher.client.model.ConfigurationElement;
import io.docs_dispatcher.client.model.ConfigurationSchema;
import io.docs_dispatcher.client.model.Types;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ConfigurationsHelpersApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public ConfigurationsHelpersApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ConfigurationsHelpersApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for configurationsGetConfiguration
     * @param configTypeName Config Type for which a configuration is requested (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsGetConfigurationCall(Types configTypeName, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/configurations/{configTypeName}/config"
            .replace("{" + "configTypeName" + "}", localVarApiClient.escapeString(configTypeName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call configurationsGetConfigurationValidateBeforeCall(Types configTypeName, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'configTypeName' is set
        if (configTypeName == null) {
            throw new ApiException("Missing the required parameter 'configTypeName' when calling configurationsGetConfiguration(Async)");
        }

        return configurationsGetConfigurationCall(configTypeName, _callback);

    }

    /**
     * Get the configuration corresponding to the given config type
     * 
     * @param configTypeName Config Type for which a configuration is requested (required)
     * @return List&lt;ConfigurationSchema&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public List<ConfigurationSchema> configurationsGetConfiguration(Types configTypeName) throws ApiException {
        ApiResponse<List<ConfigurationSchema>> localVarResp = configurationsGetConfigurationWithHttpInfo(configTypeName);
        return localVarResp.getData();
    }

    /**
     * Get the configuration corresponding to the given config type
     * 
     * @param configTypeName Config Type for which a configuration is requested (required)
     * @return ApiResponse&lt;List&lt;ConfigurationSchema&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ConfigurationSchema>> configurationsGetConfigurationWithHttpInfo(Types configTypeName) throws ApiException {
        okhttp3.Call localVarCall = configurationsGetConfigurationValidateBeforeCall(configTypeName, null);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the configuration corresponding to the given config type (asynchronously)
     * 
     * @param configTypeName Config Type for which a configuration is requested (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsGetConfigurationAsync(Types configTypeName, final ApiCallback<List<ConfigurationSchema>> _callback) throws ApiException {

        okhttp3.Call localVarCall = configurationsGetConfigurationValidateBeforeCall(configTypeName, _callback);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for configurationsGetConfigurationForProvider
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param provider The provider name for which the configuration is requested (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsGetConfigurationForProviderCall(Types configTypeName, String provider, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/configurations/{configTypeName}/providers/{provider}/config"
            .replace("{" + "configTypeName" + "}", localVarApiClient.escapeString(configTypeName.toString()))
            .replace("{" + "provider" + "}", localVarApiClient.escapeString(provider.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call configurationsGetConfigurationForProviderValidateBeforeCall(Types configTypeName, String provider, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'configTypeName' is set
        if (configTypeName == null) {
            throw new ApiException("Missing the required parameter 'configTypeName' when calling configurationsGetConfigurationForProvider(Async)");
        }

        // verify the required parameter 'provider' is set
        if (provider == null) {
            throw new ApiException("Missing the required parameter 'provider' when calling configurationsGetConfigurationForProvider(Async)");
        }

        return configurationsGetConfigurationForProviderCall(configTypeName, provider, _callback);

    }

    /**
     * Get the configuration corresponding to the given config type and the given provider
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param provider The provider name for which the configuration is requested (required)
     * @return List&lt;ConfigurationSchema&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public List<ConfigurationSchema> configurationsGetConfigurationForProvider(Types configTypeName, String provider) throws ApiException {
        ApiResponse<List<ConfigurationSchema>> localVarResp = configurationsGetConfigurationForProviderWithHttpInfo(configTypeName, provider);
        return localVarResp.getData();
    }

    /**
     * Get the configuration corresponding to the given config type and the given provider
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param provider The provider name for which the configuration is requested (required)
     * @return ApiResponse&lt;List&lt;ConfigurationSchema&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ConfigurationSchema>> configurationsGetConfigurationForProviderWithHttpInfo(Types configTypeName, String provider) throws ApiException {
        okhttp3.Call localVarCall = configurationsGetConfigurationForProviderValidateBeforeCall(configTypeName, provider, null);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the configuration corresponding to the given config type and the given provider (asynchronously)
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param provider The provider name for which the configuration is requested (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsGetConfigurationForProviderAsync(Types configTypeName, String provider, final ApiCallback<List<ConfigurationSchema>> _callback) throws ApiException {

        okhttp3.Call localVarCall = configurationsGetConfigurationForProviderValidateBeforeCall(configTypeName, provider, _callback);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for configurationsList
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> List of Configuration&#39;s json schemas </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsListCall(final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/configurations";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json",
            "text/plain"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call configurationsListValidateBeforeCall(final ApiCallback _callback) throws ApiException {
        return configurationsListCall(_callback);

    }

    /**
     * Retrieve all configurations json schema for services that are supported by Dispatcher service
     * 
     * @return List&lt;ConfigurationSchema&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> List of Configuration&#39;s json schemas </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
     </table>
     */
    public List<ConfigurationSchema> configurationsList() throws ApiException {
        ApiResponse<List<ConfigurationSchema>> localVarResp = configurationsListWithHttpInfo();
        return localVarResp.getData();
    }

    /**
     * Retrieve all configurations json schema for services that are supported by Dispatcher service
     * 
     * @return ApiResponse&lt;List&lt;ConfigurationSchema&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> List of Configuration&#39;s json schemas </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ConfigurationSchema>> configurationsListWithHttpInfo() throws ApiException {
        okhttp3.Call localVarCall = configurationsListValidateBeforeCall(null);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieve all configurations json schema for services that are supported by Dispatcher service (asynchronously)
     * 
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> List of Configuration&#39;s json schemas </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsListAsync(final ApiCallback<List<ConfigurationSchema>> _callback) throws ApiException {

        okhttp3.Call localVarCall = configurationsListValidateBeforeCall(_callback);
        Type localVarReturnType = new TypeToken<List<ConfigurationSchema>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for configurationsListProviders
     * @param configTypeName The Config Type for which list of providers is requested (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsListProvidersCall(Types configTypeName, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/api/configurations/{configTypeName}/providers"
            .replace("{" + "configTypeName" + "}", localVarApiClient.escapeString(configTypeName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call configurationsListProvidersValidateBeforeCall(Types configTypeName, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'configTypeName' is set
        if (configTypeName == null) {
            throw new ApiException("Missing the required parameter 'configTypeName' when calling configurationsListProviders(Async)");
        }

        return configurationsListProvidersCall(configTypeName, _callback);

    }

    /**
     * Get the list of implemented providers for the given config type
     * 
     * @param configTypeName The Config Type for which list of providers is requested (required)
     * @return List&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public List<String> configurationsListProviders(Types configTypeName) throws ApiException {
        ApiResponse<List<String>> localVarResp = configurationsListProvidersWithHttpInfo(configTypeName);
        return localVarResp.getData();
    }

    /**
     * Get the list of implemented providers for the given config type
     * 
     * @param configTypeName The Config Type for which list of providers is requested (required)
     * @return ApiResponse&lt;List&lt;String&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<String>> configurationsListProvidersWithHttpInfo(Types configTypeName) throws ApiException {
        okhttp3.Call localVarCall = configurationsListProvidersValidateBeforeCall(configTypeName, null);
        Type localVarReturnType = new TypeToken<List<String>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the list of implemented providers for the given config type (asynchronously)
     * 
     * @param configTypeName The Config Type for which list of providers is requested (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Configuration&#39;s json schema </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsListProvidersAsync(Types configTypeName, final ApiCallback<List<String>> _callback) throws ApiException {

        okhttp3.Call localVarCall = configurationsListProvidersValidateBeforeCall(configTypeName, _callback);
        Type localVarReturnType = new TypeToken<List<String>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for configurationsValidateConfiguration
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param configurationElement  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsValidateConfigurationCall(Types configTypeName, ConfigurationElement configurationElement, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = configurationElement;

        // create path and map variables
        String localVarPath = "/api/configurations/{configTypeName}/validate"
            .replace("{" + "configTypeName" + "}", localVarApiClient.escapeString(configTypeName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call configurationsValidateConfigurationValidateBeforeCall(Types configTypeName, ConfigurationElement configurationElement, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'configTypeName' is set
        if (configTypeName == null) {
            throw new ApiException("Missing the required parameter 'configTypeName' when calling configurationsValidateConfiguration(Async)");
        }

        return configurationsValidateConfigurationCall(configTypeName, configurationElement, _callback);

    }

    /**
     * Validate configuration for the given config type
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param configurationElement  (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public Object configurationsValidateConfiguration(Types configTypeName, ConfigurationElement configurationElement) throws ApiException {
        ApiResponse<Object> localVarResp = configurationsValidateConfigurationWithHttpInfo(configTypeName, configurationElement);
        return localVarResp.getData();
    }

    /**
     * Validate configuration for the given config type
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param configurationElement  (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Object> configurationsValidateConfigurationWithHttpInfo(Types configTypeName, ConfigurationElement configurationElement) throws ApiException {
        okhttp3.Call localVarCall = configurationsValidateConfigurationValidateBeforeCall(configTypeName, configurationElement, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Validate configuration for the given config type (asynchronously)
     * 
     * @param configTypeName Config Type corresponding to the configuration to validate (required)
     * @param configurationElement  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Unexpected error from this service </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Empty success response </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call configurationsValidateConfigurationAsync(Types configTypeName, ConfigurationElement configurationElement, final ApiCallback<Object> _callback) throws ApiException {

        okhttp3.Call localVarCall = configurationsValidateConfigurationValidateBeforeCall(configTypeName, configurationElement, _callback);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
